;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"mc68hc901.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
;$$v1
	ALIGN	4
	XDEF	_mc68hc901_uart_init
_mc68hc901_uart_init:
	link	a6,#-0
	move.l	8(a6),a0
	moveq	#-120,d0
	move.b	d0,20(a0)
	move.l	8(a6),a0
	moveq	#1,d0
	move.b	d0,21(a0)
	moveq	#1,d0
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_mc68hc901_uart_init,@function
	SIZE	_mc68hc901_uart_init,.-_mc68hc901_uart_init

; Allocations for _mc68hc901_uart_init
;	8(a6)	mc68hc901
;$$bf
;$$v1
	ALIGN	4
	XDEF	_mc68hc901_uart_in_char
_mc68hc901_uart_in_char:
	link	a6,#-0
	move.l	8(a6),a0
.L4:
	btst	#7,21(a0)
	jeq	.L4
	moveq	#0,d0
	move.b	23(a0),d0
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_mc68hc901_uart_in_char,@function
	SIZE	_mc68hc901_uart_in_char,.-_mc68hc901_uart_in_char

; Allocations for _mc68hc901_uart_in_char
;	a0	mc68hc901
;$$bf
;$$v1
	ALIGN	4
	XDEF	_mc68hc901_uart_out_char
_mc68hc901_uart_out_char:
	link	a6,#-0
	move.l	8(a6),a0
.L7:
	btst	#7,22(a0)
	jeq	.L7
	move.l	12(a6),d0
	move.b	d0,23(a0)
	moveq	#5,d0
	move.b	d0,22(a0)
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_mc68hc901_uart_out_char,@function
	SIZE	_mc68hc901_uart_out_char,.-_mc68hc901_uart_out_char

; Allocations for _mc68hc901_uart_out_char
;	a0	mc68hc901
;	12(a6)	ch
;$$bf
;$$v1
	ALIGN	4
	XDEF	_mc68hc901_uart_char_present
_mc68hc901_uart_char_present:
	link	a6,#-0
	move.l	8(a6),a0
	move.b	21(a0),d0
	and.l	#128,d0
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_mc68hc901_uart_char_present,@function
	SIZE	_mc68hc901_uart_char_present,.-_mc68hc901_uart_char_present

; Allocations for _mc68hc901_uart_char_present
;	8(a6)	mc68hc901

; Allocations for module
	
