;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"arp.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
_arp_find_pair:
	link	a6,#-0
	lea	-32(a7),a7
;$$br
	movem.l	d4/d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.w	14(a6),d7
	move.l	16(a6),a4
	move.l	20(a6),a3
	moveq	#0,d4
	tst.l	a4
	jne	.L21
	tst.l	a3
	jeq	.L20
.L21:
	tst.l	a5
	jne	.L2
.L20:
	moveq	#0,d0
	jra	.L1
.L2:
;$$fn 0x303
	jbsr	_board_disable_interrupts
	sub.l	a2,a2
	moveq	#0,d6
.L17:
	cmp.l	(a5),d6
	jcc	.L3
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	tst.l	20(a5,d1)
	jeq	.L16
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.w	4(a5,d1),d0
	sub.l	d7,d0
	tst.w	d0
	jne	.L16
	moveq	#1,d4
	tst.l	a4
	jeq	.L13
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	lea	14(a5,d1),a2
	moveq	#0,d5
.L8:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	6(a5,d1),d0
	cmp.l	d0,d5
	jge	.L14
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	7(a0,d5),d0
	move.b	0(a4,d5),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L7
	moveq	#0,d4
	jra	.L14
.L7:
	addq.l	#1,d5
	jra	.L8
.L13:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	lea	7(a5,d1),a2
	moveq	#0,d5
.L12:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	13(a5,d1),d0
	cmp.l	d0,d5
	jge	.L14
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	14(a0,d5),d0
	move.b	0(a3,d5),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L11
	moveq	#0,d4
	jra	.L14
.L11:
	addq.l	#1,d5
	jra	.L12
.L14:
	tst.l	d4
	jne	.L3
.L16:
	addq.l	#1,d6
	jra	.L17
.L3:
;$$fn 0x303
	jbsr	_board_enable_interrupts
	tst.l	d4
	jeq	.L18
	move.l	a2,d0
	jra	.L1
.L18:
	moveq	#0,d0
.L1:
;$$be
;$$br
	movem.l	-32(a6),d4/d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_find_pair,@function
	SIZE	_arp_find_pair,.-_arp_find_pair

; Allocations for _arp_find_pair
;	a5	arptab
;	d7	proto
;	a4	hwa
;	a3	pa
;	d6	slot
;	d5	i
;	d4	match
;	a2	rvalue
;$$bf
	ALIGN	4
	XDEF	_arp_merge
_arp_merge:
	link	a6,#-0
	lea	-36(a7),a7
;$$br
	movem.l	d3/d4/d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	16(a6),d7
	move.l	20(a6),a4
	move.l	24(a6),d6
	move.l	28(a6),a3
	move.l	32(a6),d5
	tst.l	a4
	jeq	.L45
	tst.l	a3
	jeq	.L45
	tst.l	a5
	jeq	.L45
	moveq	#2,d0
	cmp.l	d5,d0
	jeq	.L23
	moveq	#1,d0
	cmp.l	d5,d0
	jne	.L22
.L23:
	move.l	a3,-(a7)
	clr.l	-(a7)
	move.w	14(a6),d0
	move.l	d0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_find_pair
	lea	16(a7),a7
	move.l	d0,a2
	tst.l	a2
	jeq	.L27
	moveq	#0,d4
.L26:
	cmp.l	d7,d4
	jge	.L22
	move.b	0(a4,d4),d0
	move.b	d0,0(a2,d4)
	addq.l	#1,d4
	jra	.L26
.L27:
	moveq	#-1,d3
	moveq	#0,d4
.L31:
	moveq	#10,d0
	cmp.l	d4,d0
	jle	.L28
	move.l	d4,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	tst.l	20(a5,d1)
	jne	.L30
	move.l	d4,d3
	jra	.L28
.L30:
	addq.l	#1,d4
	jra	.L31
.L28:
	moveq	#-1,d0
	cmp.l	d3,d0
	jne	.L36
	moveq	#0,d4
.L35:
	moveq	#10,d0
	cmp.l	d4,d0
	jle	.L36
	move.l	d4,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.l	20(a5,d1),d0
	subq.l	#2,d0
	jne	.L34
	move.l	d4,d3
	jra	.L36
.L34:
	addq.l	#1,d4
	jra	.L35
.L36:
	moveq	#-1,d0
	cmp.l	d3,d0
	jne	.L37
	moveq	#9,d3
.L37:
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.w	14(a6),d0
	move.w	d0,4(a5,d1)
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.b	d7,6(a5,d1)
	moveq	#0,d4
.L40:
	cmp.l	d7,d4
	jge	.L38
	move.l	a5,a0
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	0(a4,d4),d0
	move.b	d0,7(a0,d4)
	addq.l	#1,d4
	jra	.L40
.L38:
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.b	d6,13(a5,d1)
	moveq	#0,d4
.L43:
	cmp.l	d6,d4
	jge	.L41
	move.l	a5,a0
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	0(a3,d4),d0
	move.b	d0,14(a0,d4)
	addq.l	#1,d4
	jra	.L43
.L41:
	move.l	d3,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.l	d5,20(a5,d1)
.L22:
.L45:
;$$be
;$$br
	movem.l	-36(a6),d3/d4/d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_merge,@function
	SIZE	_arp_merge,.-_arp_merge

; Allocations for _arp_merge
;	a5	arptab
;	14(a6)	proto
;	d7	hwa_size
;	a4	hwa
;	d6	pa_size
;	a3	pa
;	d5	longevity
;	d4	i
;	d3	slot
;	a2	ta
;$$bf
	ALIGN	4
	XDEF	_arp_remove
_arp_remove:
	link	a6,#-0
	lea	-24(a7),a7
;$$br
	movem.l	d4/d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.w	14(a6),d7
	move.l	16(a6),a4
	move.l	20(a6),a1
	tst.l	a4
	jne	.L70
	tst.l	a1
	jeq	.L71
.L70:
	tst.l	a5
	jeq	.L71
	moveq	#0,d6
.L68:
	cmp.l	(a5),d6
	jcc	.L46
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	tst.l	20(a5,d1)
	jeq	.L67
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	move.w	4(a5,d1),d0
	sub.l	d7,d0
	tst.w	d0
	jne	.L67
	moveq	#1,d4
	tst.l	a4
	jeq	.L58
	moveq	#0,d5
.L53:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	6(a5,d1),d0
	cmp.l	d0,d5
	jge	.L59
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	7(a0,d5),d0
	move.b	0(a4,d5),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L52
	moveq	#0,d4
	jra	.L59
.L52:
	addq.l	#1,d5
	jra	.L53
.L58:
	moveq	#0,d5
.L57:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	13(a5,d1),d0
	cmp.l	d0,d5
	jge	.L59
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.b	14(a0,d5),d0
	move.b	0(a1,d5),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L56
	moveq	#0,d4
	jra	.L59
.L56:
	addq.l	#1,d5
	jra	.L57
.L59:
	tst.l	d4
	jeq	.L67
	moveq	#0,d5
.L62:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	6(a5,d1),d0
	cmp.l	d0,d5
	jge	.L60
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.b	7(a0,d5)
	addq.l	#1,d5
	jra	.L62
.L60:
	moveq	#0,d5
.L65:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	moveq	#0,d0
	move.b	13(a5,d1),d0
	cmp.l	d0,d5
	jge	.L63
	move.l	a5,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.b	14(a0,d5)
	addq.l	#1,d5
	jra	.L65
.L63:
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	clr.l	20(a5,d1)
	jra	.L46
.L67:
	addq.l	#1,d6
	jra	.L68
.L46:
.L71:
;$$be
;$$br
	movem.l	-24(a6),d4/d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_remove,@function
	SIZE	_arp_remove,.-_arp_remove

; Allocations for _arp_remove
;	a5	arptab
;	d7	proto
;	a4	hwa
;	a1	pa
;	d6	slot
;	d5	i
;	d4	match
;$$bf
	ALIGN	4
	XDEF	_arp_request
_arp_request:
	link	a6,#-32
	lea	-16(a7),a7
;$$br
	movem.l	d7/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	moveq	#1,d0
	move.w	d0,-28(a6)
	move.w	#2048,d0
	move.w	d0,-26(a6)
	moveq	#6,d0
	move.b	d0,-24(a6)
	moveq	#4,d0
	move.b	d0,-23(a6)
	moveq	#1,d0
	move.w	d0,-22(a6)
	lea	16(a5),a3
	moveq	#0,d7
.L75:
	moveq	#6,d0
	cmp.l	d7,d0
	jle	.L73
	move.b	0(a3,d7),d0
	move.b	d0,-20(a6,d7)
	addq.l	#1,d7
	jra	.L75
.L73:
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_proto_ip_get_pa
	addq.l	#4,a7
	move.l	d0,a3
	moveq	#0,d7
.L78:
	moveq	#4,d0
	cmp.l	d7,d0
	jle	.L76
	move.b	0(a3,d7),d0
	move.b	d0,-14(a6,d7)
	addq.l	#1,d7
	jra	.L78
.L76:
	moveq	#0,d7
.L81:
	moveq	#6,d0
	cmp.l	d7,d0
	jle	.L79
	clr.b	-10(a6,d7)
	addq.l	#1,d7
	jra	.L81
.L79:
	moveq	#0,d7
.L84:
	moveq	#4,d0
	cmp.l	d7,d0
	jle	.L82
	move.b	0(a4,d7),d0
	move.b	d0,-4(a6,d7)
	addq.l	#1,d7
	jra	.L84
.L82:
	move.l	88(a5),a0
	pea	-28(a6)
	pea	28.w
	pea	2054.w
	pea	16(a5)
	pea	22(a5)
	move.l	a5,-(a7)
	jbsr	(a0)
	lea	24(a7),a7
;$$be
;$$br
	movem.l	-48(a6),d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_request,@function
	SIZE	_arp_request,.-_arp_request

; Allocations for _arp_request
;	a5	nif
;	a4	pa
;	a3	addr
;	-28(a6)	data
;	d7	i
;$$bf
	ALIGN	4
_arp_resolve_pa:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	tst.l	16(a6)
	jeq	.L88
	tst.l	8(a6)
	jeq	.L88
	moveq	#0,d0
	move.w	14(a6),d0
	tst.l	d0
	jne	.L86
.L88:
	moveq	#0,d0
	jra	.L85
.L86:
	pea	2054.w
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,a5
	move.l	16(a6),-(a7)
	clr.l	-(a7)
	move.w	14(a6),d0
	move.l	d0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_find_pair
	lea	16(a7),a7
	move.l	20(a6),a0
	move.l	d0,(a0)
	move.l	20(a6),a0
	move.l	(a0),d0
	cmp.l	#0,d0
	sne	d0
	and.l	#1,d0
.L85:
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_resolve_pa,@function
	SIZE	_arp_resolve_pa,.-_arp_resolve_pa

; Allocations for _arp_resolve_pa
;	8(a6)	nif
;	14(a6)	proto
;	16(a6)	pa
;	20(a6)	ha
;	a5	arptab
;$$bf
	ALIGN	4
	XDEF	_arp_resolve
_arp_resolve:
	link	a6,#-8
	lea	-20(a7),a7
;$$br
	movem.l	d5/d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.w	14(a6),d7
	move.l	16(a6),a4
	pea	-4(a6)
	move.l	a4,-(a7)
	move.l	d7,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_resolve_pa
	lea	16(a7),a7
	tst.l	d0
	jeq	.L90
	move.l	-4(a6),d0
	jra	.L89
.L90:
	moveq	#0,d6
.L97:
	moveq	#3,d0
	cmp.l	d6,d0
	jle	.L91
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_request
	addq.l	#8,a7
;$$fn 0x303
	jbsr	_board_enable_interrupts
	moveq	#0,d5
.L96:
	cmp.l	#524288,d5
	jge	.L93
	pea	-4(a6)
	move.l	a4,-(a7)
	move.l	d7,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_resolve_pa
	lea	16(a7),a7
	tst.l	d0
	jeq	.L95
	move.l	-4(a6),d0
	jra	.L89
.L95:
	addq.l	#1,d5
	jra	.L96
.L93:
;$$fn 0x303
	jbsr	_board_disable_interrupts
	addq.l	#1,d6
	jra	.L97
.L91:
	moveq	#0,d0
.L89:
;$$be
;$$br
	movem.l	-28(a6),d5/d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_resolve,@function
	SIZE	_arp_resolve,.-_arp_resolve

; Allocations for _arp_resolve
;	a5	nif
;	d7	proto
;	a4	pa
;	d6	i
;	d5	j
;	-4(a6)	hwa
;$$bf
	ALIGN	4
	XDEF	_proto_arp_config
_proto_arp_config:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),a1
	moveq	#10,d0
	move.l	d0,(a1)
	moveq	#0,d7
.L107:
	cmp.l	(a1),d7
	jcc	.L99
	moveq	#0,d6
.L103:
	moveq	#6,d0
	cmp.l	d6,d0
	jle	.L101
	move.l	a1,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.b	7(a0,d6)
	addq.l	#1,d6
	jra	.L103
.L101:
	moveq	#0,d6
.L106:
	moveq	#4,d0
	cmp.l	d6,d0
	jle	.L104
	move.l	a1,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.b	14(a0,d6)
	addq.l	#1,d6
	jra	.L106
.L104:
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	clr.l	20(a1,d1)
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	clr.b	6(a1,d1)
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	clr.b	13(a1,d1)
	addq.l	#1,d7
	jra	.L107
.L99:
;$$be
;$$br
	movem.l	-8(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_proto_arp_config,@function
	SIZE	_proto_arp_config,.-_proto_arp_config

; Allocations for _proto_arp_config
;	a1	arptab
;	d7	slot
;	d6	i
;$$bf
	ALIGN	4
	XDEF	_arp_handler
_arp_handler:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	pea	2054.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,a2
	moveq	#28,d0
	cmp.l	16(a6),d0
	jle	.L109
	moveq	#0,d0
	jra	.L108
.L109:
	moveq	#0,d0
	move.w	(a4),d0
	subq.l	#1,d0
	jeq	.L110
	moveq	#0,d0
	jra	.L108
.L110:
	moveq	#0,d0
	move.b	4(a4),d0
	subq.l	#6,d0
	jeq	.L111
	moveq	#0,d0
	jra	.L108
.L111:
	moveq	#0,d0
	move.w	2(a4),d0
	cmp.l	#2048,d0
	jeq	.L112
	moveq	#0,d0
	jra	.L108
.L112:
	moveq	#0,d0
	move.b	5(a4),d0
	subq.l	#4,d0
	jeq	.L113
	moveq	#0,d0
	jra	.L108
.L113:
	pea	2.w
	pea	14(a4)
	moveq	#0,d0
	move.b	5(a4),d0
	move.l	d0,-(a7)
	pea	8(a4)
	moveq	#0,d0
	move.b	4(a4),d0
	move.l	d0,-(a7)
	move.w	2(a4),d0
	move.l	d0,-(a7)
	move.l	a2,-(a7)
;$$fn 0x303
	jbsr	_arp_merge
	lea	28(a7),a7
	moveq	#0,d0
	move.w	6(a4),d0
	subq.l	#1,d0
	jne	.L114
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_proto_ip_get_pa
	addq.l	#4,a7
	move.l	d0,a3
	move.b	24(a4),d0
	move.b	(a3),d1
	sub.l	d1,d0
	tst.b	d0
	jne	.L114
	move.b	25(a4),d0
	move.b	1(a3),d1
	sub.l	d1,d0
	tst.b	d0
	jne	.L114
	move.b	26(a4),d0
	move.b	2(a3),d1
	sub.l	d1,d0
	tst.b	d0
	jne	.L114
	move.b	27(a4),d0
	move.b	3(a3),d1
	sub.l	d1,d0
	tst.b	d0
	jne	.L114
	moveq	#2,d0
	move.w	d0,6(a4)
	move.b	8(a4),18(a4)
	move.b	9(a4),19(a4)
	move.b	10(a4),20(a4)
	move.b	11(a4),21(a4)
	move.b	12(a4),22(a4)
	move.b	13(a4),23(a4)
	move.b	14(a4),24(a4)
	move.b	15(a4),25(a4)
	move.b	16(a4),26(a4)
	move.b	17(a4),27(a4)
	lea	16(a5),a3
	move.b	(a3),8(a4)
	move.b	1(a3),9(a4)
	move.b	2(a3),10(a4)
	move.b	3(a3),11(a4)
	move.b	4(a3),12(a4)
	move.b	5(a3),13(a4)
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,-(a7)
;$$fn 0x303
	jbsr	_proto_ip_get_pa
	addq.l	#4,a7
	move.l	d0,a3
	move.b	(a3),14(a4)
	move.b	1(a3),15(a4)
	move.b	2(a3),16(a4)
	move.b	3(a3),17(a4)
	move.l	88(a5),a0
	move.l	a4,-(a7)
	pea	28.w
	pea	2054.w
	pea	8(a4)
	pea	18(a4)
	move.l	a5,-(a7)
	jbsr	(a0)
	lea	24(a7),a7
.L114:
	moveq	#0,d0
.L108:
;$$be
;$$br
	movem.l	-16(a6),a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_arp_handler,@function
	SIZE	_arp_handler,.-_arp_handler

; Allocations for _arp_handler
;	a5	nif
;	a4	arpframe
;	16(a6)	frame_length
;	a3	addr
;	a2	arptab

; Allocations for module
	
