;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"ip.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
	XDEF	_proto_ip_config
_proto_ip_config:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
	move.l	a4,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	move.l	16(a6),a1
	move.l	20(a6),a0
	moveq	#0,d1
.L4:
	moveq	#4,d0
	cmp.l	d1,d0
	jls	.L2
	move.b	0(a4,d1),d0
	move.b	d0,0(a5,d1)
	move.b	0(a1,d1),d0
	move.b	d0,4(a5,d1)
	move.b	0(a0,d1),d0
	move.b	d0,8(a5,d1)
	moveq	#-1,d0
	move.b	d0,12(a5,d1)
	addq.l	#1,d1
	jra	.L4
.L2:
	clr.l	16(a5)
	clr.l	20(a5)
	clr.l	24(a5)
	clr.l	28(a5)
	move.l	#57005,d0
	move.l	d0,_ip_ident
;$$be
;$$br
	movem.l	-8(a6),a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_proto_ip_config,@function
	SIZE	_proto_ip_config,.-_proto_ip_config

; Allocations for _proto_ip_config
;	a5	info
;	a4	myip
;	a1	gateway
;	a0	netmask
;	d1	index
;$$bf
	ALIGN	4
	XDEF	_proto_ip_get_pa
_proto_ip_get_pa:
	link	a6,#-0
	tst.l	8(a6)
	jeq	.L6
	move.l	8(a6),d0
	jra	.L5
.L6:
	moveq	#0,d0
.L5:
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_proto_ip_get_pa,@function
	SIZE	_proto_ip_get_pa,.-_proto_ip_get_pa

; Allocations for _proto_ip_get_pa
;	8(a6)	info
;$$bf
	ALIGN	4
	XDEF	_ip_addr_compare
_ip_addr_compare:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),a1
	move.l	12(a6),a0
	moveq	#0,d7
.L11:
	moveq	#4,d0
	cmp.l	d7,d0
	jls	.L8
	move.b	0(a1,d7),d0
	move.b	0(a0,d7),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L10
	moveq	#0,d0
	jra	.L7
.L10:
	addq.l	#1,d7
	jra	.L11
.L8:
	moveq	#1,d0
.L7:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_addr_compare,@function
	SIZE	_ip_addr_compare,.-_ip_addr_compare

; Allocations for _ip_addr_compare
;	a1	addr1
;	a0	addr2
;	d7	i
;$$bf
	ALIGN	4
	XDEF	_ip_resolve_route
_ip_resolve_route:
	link	a6,#-8
	lea	-16(a7),a7
;$$br
	movem.l	d7/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,a3
	moveq	#0,d7
.L15:
	moveq	#4,d0
	cmp.l	d7,d0
	jls	.L13
	move.b	0(a3,d7),d0
	move.b	8(a3,d7),d1
	and.l	d1,d0
	move.b	d0,-4(a6,d7)
	addq.l	#1,d7
	jra	.L15
.L13:
	moveq	#0,d7
.L18:
	moveq	#4,d0
	cmp.l	d7,d0
	jls	.L16
	move.b	-4(a6,d7),d0
	move.b	0(a4,d7),d1
	and.l	d1,d0
	move.b	d0,-8(a6,d7)
	addq.l	#1,d7
	jra	.L18
.L16:
	pea	-8(a6)
	pea	-4(a6)
;$$fn 0x303
	jbsr	_ip_addr_compare
	addq.l	#8,a7
	tst.l	d0
	jeq	.L19
	move.l	a4,-(a7)
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_resolve
	lea	12(a7),a7
	jra	.L12
.L19:
	pea	4(a3)
	pea	2048.w
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_arp_resolve
	lea	12(a7),a7
.L12:
;$$be
;$$br
	movem.l	-24(a6),d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_resolve_route,@function
	SIZE	_ip_resolve_route,.-_ip_resolve_route

; Allocations for _ip_resolve_route
;	a5	nif
;	a4	destip
;	a3	info
;	-4(a6)	mask1
;	-8(a6)	result
;	d7	i
;$$bf
	ALIGN	4
	XDEF	_ip_send
_ip_send:
	link	a6,#-1504
	lea	-24(a7),a7
;$$br
	movem.l	d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	move.l	16(a6),a3
	move.l	24(a6),a2
	move.l	28(a6),d7
	moveq	#69,d0
	move.b	d0,-1500(a6)
	clr.b	-1499(a6)
	move.l	d7,d0
	add.l	#20,d0
	move.w	d0,-1498(a6)
	move.l	_ip_ident,d0
	move.w	d0,-1496(a6)
	subq.l	#1,_ip_ident
	clr.w	-1494(a6)
	moveq	#-1,d0
	move.b	d0,-1492(a6)
	move.l	20(a6),d0
	move.b	d0,-1491(a6)
	clr.w	-1490(a6)
	move.b	(a3),-1488(a6)
	move.b	1(a3),-1487(a6)
	move.b	2(a3),-1486(a6)
	move.b	3(a3),-1485(a6)
	move.b	(a4),-1484(a6)
	move.b	1(a4),-1483(a6)
	move.b	2(a4),-1482(a6)
	move.b	3(a4),-1481(a6)
	tst.l	a2
	jeq	.L27
	moveq	#0,d6
.L24:
	cmp.l	d7,d6
	jge	.L25
	move.l	a6,a0
	add.l	d6,a0
	move.b	0(a2,d6),d0
	move.b	d0,-1480(a0)
	addq.l	#1,d6
	jra	.L24
.L25:
.L27:
	pea	20.w
	pea	-1500(a6)
;$$fn 0x303
	jbsr	_ip_chksum
	addq.l	#8,a7
	move.w	d0,-1490(a6)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_ip_resolve_route
	addq.l	#8,a7
	move.l	d0,-1504(a6)
	tst.l	-1504(a6)
	jne	.L26
	moveq	#0,d0
	move.b	3(a4),d0
	move.l	d0,-(a7)
	moveq	#0,d0
	move.b	2(a4),d0
	move.l	d0,-(a7)
	moveq	#0,d0
	move.b	1(a4),d0
	move.l	d0,-(a7)
	moveq	#0,d0
	move.b	(a4),d0
	move.l	d0,-(a7)
	lea	.L28,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	20(a7),a7
	moveq	#0,d0
	jra	.L21
.L26:
	move.l	88(a5),a0
	pea	-1500(a6)
	move.l	d7,a1
	pea	20(a1)
	pea	2048.w
	pea	16(a5)
	move.l	-1504(a6),-(a7)
	move.l	a5,-(a7)
	jbsr	(a0)
	lea	24(a7),a7
.L21:
;$$be
;$$br
	movem.l	-1528(a6),d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_send,@function
	SIZE	_ip_send,.-_ip_send

; Allocations for _ip_send
;	a5	nif
;	a4	dest
;	a3	src
;	20(a6)	protocol
;	a2	data
;	d7	length
;	d6	i
;	-1500(a6)	outdata
;	-1504(a6)	route
;$$bf
	ALIGN	4
	XDEF	_ip_chksum
_ip_chksum:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d5/d6/d7,(a7)
;$$er
	move.l	8(a6),a0
	move.l	12(a6),d7
	moveq	#0,d6
	asr.l	#1,d7
.L33:
	tst.l	d7
	jeq	.L30
	move.w	(a0),d1
	moveq	#0,d5
	move.w	d1,d5
	add.l	d6,d5
	and.l	#65535,d5
	and.l	#65535,d1
	cmp.l	d1,d5
	jlt	.L34
	cmp.l	d6,d5
	jge	.L32
.L34:
	addq.l	#1,d5
	and.l	#65535,d5
.L32:
	move.l	d5,d6
	subq.l	#1,d7
	addq.l	#2,a0
	jra	.L33
.L30:
	move.l	d6,d0
	not.l	d0
;$$be
;$$br
	movem.l	-12(a6),d5/d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_chksum,@function
	SIZE	_ip_chksum,.-_ip_chksum

; Allocations for _ip_chksum
;	a0	data
;	d7	num
;	d6	chksum
;	d5	ichksum
;	d1	temp
;$$bf
	ALIGN	4
_validate_ip_hdr:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	12(a6),a5
	move.b	(a5),d0
	and.l	#240,d0
	asr.l	#4,d0
	subq.l	#4,d0
	jeq	.L36
	moveq	#0,d0
	jra	.L35
.L36:
	move.b	(a5),d0
	and.l	#15,d0
	subq.l	#5,d0
	jge	.L37
	moveq	#0,d0
	jra	.L35
.L37:
	pea	2048.w
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_nif_proto_config
	addq.l	#8,a7
	move.l	d0,a4
	moveq	#0,d7
.L41:
	moveq	#4,d0
	cmp.l	d7,d0
	jls	.L38
	move.b	0(a4,d7),d0
	move.b	16(a5,d7),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L40
	moveq	#0,d0
	jra	.L35
.L40:
	addq.l	#1,d7
	jra	.L41
.L38:
	moveq	#0,d6
	move.w	10(a5),d6
	clr.w	10(a5)
	move.b	(a5),d0
	and.l	#15,d0
	lsl.l	#2,d0
	move.l	d0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x103
	jbsr	_ip_chksum
	addq.l	#8,a7
	moveq	#0,d1
	move.w	d0,d1
	cmp.l	d1,d6
	jeq	.L42
	moveq	#0,d0
	jra	.L35
.L42:
	move.w	d6,10(a5)
	moveq	#1,d0
.L35:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_validate_ip_hdr,@function
	SIZE	_validate_ip_hdr,.-_validate_ip_hdr

; Allocations for _validate_ip_hdr
;	8(a6)	nif
;	a5	ipframe
;	d7	index
;	d6	chksum
;	a4	info
;$$bf
	ALIGN	4
	XDEF	_ip_handler
_ip_handler:
	link	a6,#-0
	lea	-20(a7),a7
;$$br
	movem.l	d6/d7/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_validate_ip_hdr
	addq.l	#8,a7
	tst.l	d0
	jne	.L44
	moveq	#0,d0
	jra	.L43
.L44:
	move.b	(a4),d0
	and.l	#15,d0
	lea	(a4,d0*4),a3
	moveq	#0,d7
	move.w	2(a4),d7
	move.b	(a4),d1
	and.l	#15,d1
	lsl.l	#2,d1
	sub.l	d1,d7
	moveq	#0,d0
	move.b	9(a4),d0
	subq.l	#1,d0
	jeq	.L46
	add.l	#-16,d0
	jeq	.L47
	jra	.L48
.L46:
	move.l	d7,-(a7)
	move.l	a3,-(a7)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_icmp_handler
	lea	16(a7),a7
	moveq	#0,d6
	jra	.L45
.L47:
	move.l	d7,-(a7)
	move.l	a3,-(a7)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_udp_handler
	lea	16(a7),a7
	move.l	d0,d6
	jra	.L45
.L48:
	moveq	#0,d6
.L45:
	move.l	d6,d0
.L43:
;$$be
;$$br
	movem.l	-20(a6),d6/d7/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_handler,@function
	SIZE	_ip_handler,.-_ip_handler

; Allocations for _ip_handler
;	a5	nif
;	a4	ipframe
;	not allocated	frame_length
;	a3	data
;	d7	length
;	d6	keep
;$$bf
	ALIGN	4
_valid_ip_wait:
	link	a6,#-0
	move.l	12(a6),-(a7)
	move.l	8(a6),-(a7)
;$$fn 0x303
	jbsr	_validate_ip_hdr
	addq.l	#8,a7
	tst.l	d0
	jeq	.L51
	move.l	12(a6),a0
	moveq	#0,d0
	move.b	9(a0),d0
	cmp.l	16(a6),d0
	jne	.L51
	moveq	#1,d0
	jra	.L49
.L51:
	moveq	#0,d0
.L49:
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_valid_ip_wait,@function
	SIZE	_valid_ip_wait,.-_valid_ip_wait

; Allocations for _valid_ip_wait
;	8(a6)	nif
;	12(a6)	ipframe
;	16(a6)	protocol
;$$bf
	ALIGN	4
	XDEF	_ip_wait
_ip_wait:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d6/d7/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	16(a6),d7
	move.l	20(a6),d6
	tst.l	12(a6)
	jne	.L53
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_nbuf_init_traversal
	addq.l	#4,a7
	move.l	d0,a4
	jra	.L54
.L53:
	move.l	d6,-(a7)
	move.l	12(a6),-(a7)
;$$fn 0x303
	jbsr	_nbuf_traverse
	addq.l	#8,a7
	move.l	d0,a4
.L54:
	tst.l	a4
	jeq	.L56
	move.l	d7,-(a7)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_valid_ip_wait
	lea	12(a7),a7
	tst.l	d0
	jeq	.L59
	move.l	a4,d0
	jra	.L52
.L56:
	moveq	#0,d0
	jra	.L52
.L59:
	subq.l	#1,d6
	jeq	.L58
	move.l	d6,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_nbuf_traverse
	addq.l	#8,a7
	move.l	d0,a4
	move.l	d7,-(a7)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_valid_ip_wait
	lea	12(a7),a7
	tst.l	d0
	jeq	.L59
	move.l	a4,d0
	jra	.L52
.L58:
	moveq	#0,d0
.L52:
;$$be
;$$br
	movem.l	-16(a6),d6/d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ip_wait,@function
	SIZE	_ip_wait,.-_ip_wait

; Allocations for _ip_wait
;	a5	nif
;	12(a6)	start
;	d7	protocol
;	d6	timeout
;	a4	ipframe

; Allocations for module
	LCOMM	_ip_ident,4
	ALIGN	4
.L28:
	ASCII	"ip_send():  Unable to locate %d.%d.%d.%d\n"
	DC.B	0
	
