;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"brktab.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
_breakpoint_clear:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),d7
	tst.l	d7
	jmi	.L2
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L2
	move.l	#_brktab,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_brktab+4,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.w	(a0)
	move.l	#_brktab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_brktab+12,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_brktab+16,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
.L2:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_clear,@function
	SIZE	_breakpoint_clear,.-_breakpoint_clear

; Allocations for _breakpoint_clear
;	d7	index
;$$bf
	ALIGN	4
	XDEF	_breakpoint_init
_breakpoint_init:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	moveq	#0,d7
.L6:
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L4
	move.l	d7,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_clear
	addq.l	#4,a7
	addq.l	#1,d7
	jra	.L6
.L4:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_init,@function
	SIZE	_breakpoint_init,.-_breakpoint_init

; Allocations for _breakpoint_init
;	d7	index
;$$bf
	ALIGN	4
_breakpoint_find:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),d7
	moveq	#0,d6
.L11:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L8
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L10
	move.l	d6,d0
	jra	.L7
.L10:
	addq.l	#1,d6
	jra	.L11
.L8:
	moveq	#-1,d0
.L7:
;$$be
;$$br
	movem.l	-8(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_find,@function
	SIZE	_breakpoint_find,.-_breakpoint_find

; Allocations for _breakpoint_find
;	d7	address
;	d6	index
;$$bf
	ALIGN	4
_breakpoint_display_info:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),d7
	tst.l	d7
	jmi	.L13
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L13
	move.l	#_brktab+12,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),-(a7)
	move.l	#_brktab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),-(a7)
	move.l	#_brktab,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),-(a7)
	lea	.L14,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	lea	16(a7),a7
.L13:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_display_info,@function
	SIZE	_breakpoint_display_info,.-_breakpoint_display_info

; Allocations for _breakpoint_display_info
;	d7	index
;$$bf
	ALIGN	4
_breakpoint_display:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	12(a6),a5
	lea	.L28,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	tst.l	4(a5)
	jne	.L26
	moveq	#0,d6
.L19:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L27
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jeq	.L18
	move.l	d6,-(a7)
;$$fn 0x303
	jbsr	_breakpoint_display_info
	addq.l	#4,a7
.L18:
	addq.l	#1,d6
	jra	.L19
.L26:
	moveq	#1,d6
.L21:
	tst.l	(a5,d6*4)
	jeq	.L27
	pea	16.w
	clr.l	-(a7)
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_strtoul
	lea	12(a7),a7
	move.l	d0,d7
	moveq	#0,d5
.L25:
	moveq	#10,d0
	cmp.l	d5,d0
	jle	.L22
	move.l	#_brktab,a0
	move.l	d5,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L24
	move.l	d5,-(a7)
;$$fn 0x303
	jbsr	_breakpoint_display_info
	addq.l	#4,a7
.L24:
	addq.l	#1,d5
	jra	.L25
.L22:
	addq.l	#1,d6
	jra	.L21
.L27:
;$$be
;$$br
	movem.l	-16(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_display,@function
	SIZE	_breakpoint_display,.-_breakpoint_display

; Allocations for _breakpoint_display
;	not allocated	argc
;	a5	argv
;	d7	address
;	d6	i
;	d5	j
;$$bf
	ALIGN	4
_breakpoint_set_count:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),-(a7)
;$$fn 0x103
	jbsr	_breakpoint_find
	addq.l	#4,a7
	move.l	d0,d7
	tst.l	d7
	jmi	.L30
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L30
	move.l	#_brktab+8,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	12(a6),d0
	move.l	d0,(a0)
.L30:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_set_count,@function
	SIZE	_breakpoint_set_count,.-_breakpoint_set_count

; Allocations for _breakpoint_set_count
;	8(a6)	brkpnt
;	12(a6)	count
;	d7	index
;$$bf
	ALIGN	4
_breakpoint_set_all_count:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),d7
	moveq	#0,d6
.L34:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L32
	move.l	#_brktab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d7,(a0)
	addq.l	#1,d6
	jra	.L34
.L32:
;$$be
;$$br
	movem.l	-8(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_set_all_count,@function
	SIZE	_breakpoint_set_all_count,.-_breakpoint_set_all_count

; Allocations for _breakpoint_set_all_count
;	d7	value
;	d6	index
;$$bf
	ALIGN	4
_breakpoint_set_trigger:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),-(a7)
;$$fn 0x103
	jbsr	_breakpoint_find
	addq.l	#4,a7
	move.l	d0,d7
	tst.l	d7
	jmi	.L36
	moveq	#10,d0
	cmp.l	d7,d0
	jle	.L36
	move.l	#_brktab+12,a0
	move.l	d7,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	12(a6),d0
	move.l	d0,(a0)
.L36:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_set_trigger,@function
	SIZE	_breakpoint_set_trigger,.-_breakpoint_set_trigger

; Allocations for _breakpoint_set_trigger
;	8(a6)	brkpnt
;	12(a6)	count
;	d7	index
;$$bf
	ALIGN	4
_breakpoint_set_all_trigger:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),d7
	moveq	#0,d6
.L40:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L38
	move.l	#_brktab+12,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d7,(a0)
	addq.l	#1,d6
	jra	.L40
.L38:
;$$be
;$$br
	movem.l	-8(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_set_all_trigger,@function
	SIZE	_breakpoint_set_all_trigger,.-_breakpoint_set_all_trigger

; Allocations for _breakpoint_set_all_trigger
;	d7	value
;	d6	index
;$$bf
	ALIGN	4
	XDEF	_breakpoint_remove
_breakpoint_remove:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
;$$er
	move.l	8(a6),-(a7)
;$$fn 0x103
	jbsr	_breakpoint_find
	addq.l	#4,a7
	move.l	d0,d7
	moveq	#-1,d0
	cmp.l	d7,d0
	jeq	.L42
	move.l	d7,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_clear
	addq.l	#4,a7
.L42:
;$$be
;$$br
	move.l	-4(a6),d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_remove,@function
	SIZE	_breakpoint_remove,.-_breakpoint_remove

; Allocations for _breakpoint_remove
;	8(a6)	address
;	d7	index
;$$bf
	ALIGN	4
	XDEF	_breakpoint_add
_breakpoint_add:
	link	a6,#-0
;$$br
	move.l	d7,-(a7)
	move.l	d6,-(a7)
;$$er
	move.l	8(a6),d7
	move.l	d7,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_find
	addq.l	#4,a7
	addq.l	#1,d0
	jne	.L43
	moveq	#0,d6
.L48:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L45
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jeq	.L45
	addq.l	#1,d6
	jra	.L48
.L45:
	moveq	#10,d0
	cmp.l	d6,d0
	jne	.L49
	lea	.L53,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	jra	.L43
.L49:
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_cpu_invalid_instr_addr
	addq.l	#4,a7
	tst.l	d0
	jeq	.L50
	lea	.L54,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	jra	.L43
.L50:
	move.l	#_brktab+4,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d7,a1
	move.w	(a1),(a0)
	move.l	d7,a0
	move.w	#19196,(a0)
	move.l	d7,a0
	moveq	#0,d0
	move.w	(a0),d0
	cmp.l	#19196,d0
	jeq	.L51
	lea	.L55,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	jra	.L43
.L51:
	move.l	d7,a0
	move.l	#_brktab+4,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.w	(a1),(a0)
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	d7,(a0)
	move.l	#_brktab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
	move.l	#_brktab+12,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	moveq	#1,d0
	move.l	d0,(a0)
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	12(a6),d0
	move.l	d0,(a0)
.L43:
;$$be
;$$br
	movem.l	-8(a6),d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_add,@function
	SIZE	_breakpoint_add,.-_breakpoint_add

; Allocations for _breakpoint_add
;	d7	address
;	12(a6)	type
;	d6	i
;$$bf
	ALIGN	4
	XDEF	_breakpoint_install
_breakpoint_install:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d5/d6/d7,(a7)
;$$er
	move.l	8(a6),d7
	moveq	#0,d5
	moveq	#0,d6
.L62:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L57
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jeq	.L61
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L59
	moveq	#1,d5
	jra	.L61
.L59:
	move.l	#_brktab+4,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	#_brktab,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),a1
	move.w	(a1),(a0)
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),a0
	move.w	#19196,(a0)
.L61:
	addq.l	#1,d6
	jra	.L62
.L57:
;$$fn 0x303
	jbsr	_cpu_icache_flush
;$$fn 0x303
	jbsr	_cpu_dcache_flush
	move.l	d5,d0
;$$be
;$$br
	movem.l	-12(a6),d5/d6/d7
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_install,@function
	SIZE	_breakpoint_install,.-_breakpoint_install

; Allocations for _breakpoint_install
;	d7	address
;	d6	index
;	d5	found
;$$bf
	ALIGN	4
	XDEF	_breakpoint_deinstall
_breakpoint_deinstall:
	link	a6,#-0
	lea	-16(a7),a7
;$$br
	movem.l	d5/d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	moveq	#0,d5
	clr.l	(a5)
	moveq	#0,d6
.L70:
	moveq	#10,d0
	cmp.l	d6,d0
	jle	.L64
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	tst.l	(a0)
	jeq	.L69
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),a0
	move.l	#_brktab+4,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.w	(a1),(a0)
	move.l	#_brktab,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	cmp.l	(a0),d7
	jne	.L67
	moveq	#1,d5
	move.l	#_brktab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	addq.l	#1,(a0)
	move.l	#_brktab+8,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	#_brktab+12,a1
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a1
	move.l	(a1),d0
	cmp.l	(a0),d0
	jgt	.L67
	moveq	#1,d0
	move.l	d0,(a5)
.L67:
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	move.l	(a0),d0
	subq.l	#2,d0
	jne	.L69
	move.l	#_brktab+16,a0
	move.l	d6,d0
	lsl.l	#2,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d0,d1
	add.l	d1,a0
	clr.l	(a0)
.L69:
	addq.l	#1,d6
	jra	.L70
.L64:
;$$fn 0x303
	jbsr	_cpu_icache_flush
;$$fn 0x303
	jbsr	_cpu_dcache_flush
	move.l	d5,d0
;$$be
;$$br
	movem.l	-16(a6),d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint_deinstall,@function
	SIZE	_breakpoint_deinstall,.-_breakpoint_deinstall

; Allocations for _breakpoint_deinstall
;	d7	address
;	a5	triggered
;	d6	index
;	d5	found
;$$bf
	ALIGN	4
	XDEF	_breakpoint
_breakpoint:
	link	a6,#-8
	lea	-20(a7),a7
;$$br
	movem.l	d4/d5/d6/d7/a5,(a7)
;$$er
	move.l	8(a6),d7
	move.l	12(a6),a5
	moveq	#-1,d4
	moveq	#1,d0
	cmp.l	d7,d0
	jne	.L72
	move.l	a5,-(a7)
	move.l	d7,-(a7)
;$$fn 0x303
	jbsr	_breakpoint_display
	addq.l	#8,a7
	jra	.L71
.L72:
	moveq	#1,d6
.L74:
	cmp.l	d7,d6
	jge	.L71
	move.l	(a5,d6*4),a0
	move.b	(a0),d0
	extb.l	d0
	moveq	#45,d1
	cmp.l	d0,d1
	jeq	.L104
	pea	16.w
	pea	-4(a6)
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_get_value
	lea	12(a7),a7
	move.l	d0,d4
	tst.l	-4(a6)
	jne	.L75
	move.l	(a5,d6*4),-(a7)
	lea	.L107,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
	jra	.L71
.L75:
	pea	1.w
	move.l	d4,-(a7)
;$$fn 0x303
	jbsr	_breakpoint_add
	addq.l	#8,a7
	addq.l	#1,d6
	jra	.L74
.L104:
	move.l	(a5,d6*4),a0
	move.b	1(a0),d0
	extb.l	d0
	add.l	#-99,d0
	jgt	.L108
	jeq	.L78
	add.l	#32,d0
	jeq	.L78
	subq.l	#6,d0
	jeq	.L102
	add.l	#-9,d0
	jeq	.L92
	subq.l	#2,d0
	jeq	.L85
	jra	.L103
.L108:
	subq.l	#6,d0
	jeq	.L102
	add.l	#-9,d0
	jeq	.L92
	subq.l	#2,d0
	jeq	.L85
	jra	.L103
.L78:
	tst.l	(4,a5,d6*4)
	jne	.L80
	moveq	#0,d5
	jra	.L81
.L80:
	addq.l	#1,d6
	move.l	_BASE,-(a7)
	pea	-8(a6)
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_strtoul
	lea	12(a7),a7
	move.l	d0,d5
	tst.l	d5
	jne	.L81
	move.l	(a5,d6*4),a0
	cmp.l	-8(a6),a0
	jne	.L81
	moveq	#0,d5
.L81:
	moveq	#-1,d0
	cmp.l	d4,d0
	jne	.L82
	move.l	d5,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_set_all_count
	addq.l	#4,a7
	jra	.L71
.L82:
	move.l	d5,-(a7)
	move.l	d4,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_set_count
	addq.l	#8,a7
	jra	.L76
.L85:
	tst.l	(4,a5,d6*4)
	jne	.L87
	moveq	#1,d5
	jra	.L88
.L87:
	addq.l	#1,d6
	move.l	_BASE,-(a7)
	pea	-8(a6)
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_strtoul
	lea	12(a7),a7
	move.l	d0,d5
	tst.l	d5
	jne	.L88
	move.l	(a5,d6*4),a0
	cmp.l	-8(a6),a0
	jne	.L88
	moveq	#1,d5
.L88:
	moveq	#-1,d0
	cmp.l	d4,d0
	jne	.L89
	move.l	d5,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_set_all_trigger
	addq.l	#4,a7
	jra	.L71
.L89:
	move.l	d5,-(a7)
	move.l	d4,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_set_trigger
	addq.l	#8,a7
	jra	.L76
.L92:
	moveq	#-1,d0
	cmp.l	d4,d0
	jne	.L99
	tst.l	(4,a5,d6*4)
	jne	.L94
;$$fn 0x103
	jbsr	_breakpoint_init
	jra	.L76
.L94:
	addq.l	#1,d6
	cmp.l	d7,d6
	jge	.L76
	pea	16.w
	pea	-4(a6)
	move.l	(a5,d6*4),-(a7)
;$$fn 0x303
	jbsr	_get_value
	lea	12(a7),a7
	move.l	d0,d4
	tst.l	-4(a6)
	jne	.L95
;$$fn 0x103
	jbsr	_breakpoint_init
	jra	.L94
.L95:
	move.l	d4,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_remove
	addq.l	#4,a7
	jra	.L94
.L99:
	move.l	d4,-(a7)
;$$fn 0x103
	jbsr	_breakpoint_remove
	addq.l	#4,a7
	jra	.L76
.L102:
	pea	1.w
;$$fn 0x103
	jbsr	_breakpoint_set_all_trigger
	addq.l	#4,a7
	clr.l	-(a7)
;$$fn 0x103
	jbsr	_breakpoint_set_all_count
	addq.l	#4,a7
	jra	.L76
.L103:
	move.l	4(a5),-(a7)
	lea	.L109,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#8,a7
.L76:
	addq.l	#1,d6
	jra	.L74
.L71:
;$$be
;$$br
	movem.l	-28(a6),d4/d5/d6/d7/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_breakpoint,@function
	SIZE	_breakpoint,.-_breakpoint

; Allocations for _breakpoint
;	d7	argc
;	a5	argv
;	d6	i
;	d5	value
;	-4(a6)	success
;	d4	brkpnt
;	-8(a6)	p

; Allocations for module
	COMM	_brktab,200
	ALIGN	4
.L14:
	ASCII	"%08X:  %08X %08X\n"
	DC.B	0
	ALIGN	4
.L28:
	ASCII	" Address      Count  Trigger\n"
	DC.B	0
	ALIGN	4
.L53:
	ASCII	"Break table full.\n"
	DC.B	0
	ALIGN	4
.L54:
	ASCII	"Error:  Invalid breakpoint address!\n"
	DC.B	0
	ALIGN	4
.L55:
	ASCII	"Error:  Address is read-only!\n"
	DC.B	0
	ALIGN	4
.L107:
	ASCII	"Error:  Bad Value:  %s\n"
	DC.B	0
	ALIGN	4
.L109:
	ASCII	"Error:  Invalid option:  %s\n"
	DC.B	0
	
