;$$p5200	- MCF5200 CPU
;$$o5200	- MCF5200 opt
;$$m4		- ELFEMB mnem.
;$$ko 0		- Reorder info
;$$sz 0		- Size opt info
	NAME	"ns8390.c"
; -X options:
;$$x X1=4 X7=1 X8=1 X12=1 X15=2 X16=20 X17=1 X18=4
;$$x X19=1 X35=1 X39=5200 X44=1 X71=1 X74=5 X76=1 X80=1
;$$x X84=-2 X86=6 X91=1 X93=4 X111=1 X114=7 X116=1 X119=44
;$$x X201=136
	PSECT
;$$bf
	ALIGN	4
_set_dma_read_at:
	link	a6,#-0
	move.l	8(a6),a1
	moveq	#34,d0
	move.w	d0,(a1)
	move.l	a1,a0
	add.l	#65546,a0
	move.l	16(a6),d0
	asr.l	#8,d0
	and.l	#255,d0
	move.w	d0,(a0)
	move.l	16(a6),d0
	and.l	#255,d0
	move.w	d0,10(a1)
	move.l	a1,a0
	add.l	#65544,a0
	move.l	12(a6),d0
	asr.l	#8,d0
	and.l	#255,d0
	move.w	d0,(a0)
	move.l	12(a6),d0
	and.l	#255,d0
	move.w	d0,8(a1)
	moveq	#10,d0
	move.w	d0,(a1)
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_set_dma_read_at,@function
	SIZE	_set_dma_read_at,.-_set_dma_read_at

; Allocations for _set_dma_read_at
;	a1	ns8390
;	12(a6)	addr
;	16(a6)	size
;$$bf
	ALIGN	4
_set_dma_write_at:
	link	a6,#-8
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	pea	2.w
	pea	70.w
	move.l	a5,-(a7)
;$$fn 0x301
	jbsr	_set_dma_read_at
	lea	12(a7),a7
	moveq	#0,d0
	move.w	16(a5),d0
	move.l	d0,-4(a6)
	moveq	#34,d0
	move.w	d0,(a5)
	move.l	a5,a0
	add.l	#65546,a0
	move.l	16(a6),d0
	asr.l	#8,d0
	and.l	#255,d0
	move.w	d0,(a0)
	move.l	16(a6),d0
	and.l	#255,d0
	move.w	d0,10(a5)
	move.l	a5,a0
	add.l	#65544,a0
	move.l	12(a6),d0
	asr.l	#8,d0
	and.l	#255,d0
	move.w	d0,(a0)
	move.l	12(a6),d0
	and.l	#255,d0
	move.w	d0,8(a5)
	moveq	#18,d0
	move.w	d0,(a5)
;$$be
;$$br
	move.l	-12(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_set_dma_write_at,@function
	SIZE	_set_dma_write_at,.-_set_dma_write_at

; Allocations for _set_dma_write_at
;	a5	ns8390
;	12(a6)	addr
;	16(a6)	size
;	-4(a6)	dummy_read
;$$bf
	ALIGN	4
_read_eth_addr:
	link	a6,#-32
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a1
	moveq	#33,d0
	move.w	d0,(a5)
	moveq	#64,d0
	move.w	d0,14(a5)
	clr.w	10(a5)
	move.l	a5,a0
	add.l	#65546,a0
	clr.w	(a0)
	move.l	a5,a0
	add.l	#65550,a0
	clr.w	(a0)
	move.l	a5,a0
	add.l	#65542,a0
	move.w	#65535,d0
	move.w	d0,(a0)
	moveq	#32,d0
	move.w	d0,12(a5)
	move.l	a5,a0
	add.l	#65548,a0
	moveq	#2,d0
	move.w	d0,(a0)
	moveq	#32,d0
	move.w	d0,10(a5)
	move.l	a5,a0
	add.l	#65546,a0
	clr.w	(a0)
	clr.w	8(a5)
	move.l	a5,a0
	add.l	#65544,a0
	clr.w	(a0)
	moveq	#10,d0
	move.w	d0,(a5)
	moveq	#0,d1
.L6:
	moveq	#32,d0
	cmp.l	d1,d0
	jle	.L4
	move.w	16(a5),d0
	move.b	d0,-32(a6,d1)
	addq.l	#1,d1
	jra	.L6
.L4:
	moveq	#0,d1
.L9:
	moveq	#6,d0
	cmp.l	d1,d0
	jle	.L7
	move.b	(-32,a6,d1*2),d0
	move.b	d0,0(a1,d1)
	addq.l	#1,d1
	jra	.L9
.L7:
	moveq	#33,d0
	move.w	d0,(a5)
;$$be
;$$br
	move.l	-36(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_read_eth_addr,@function
	SIZE	_read_eth_addr,.-_read_eth_addr

; Allocations for _read_eth_addr
;	a5	ns8390
;	a1	hwa
;	d1	i
;	-32(a6)	eeprom
;$$bf
	ALIGN	4
	XDEF	_ns8390_reset
_ns8390_reset:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	move.l	96(a5),a1
	moveq	#33,d0
	move.w	d0,(a1)
	moveq	#67,d0
	move.w	d0,14(a1)
	clr.w	10(a1)
	move.l	a1,a0
	add.l	#65546,a0
	clr.w	(a0)
	moveq	#4,d0
	move.w	d0,12(a1)
	move.l	a1,a0
	add.l	#65548,a0
	moveq	#2,d0
	move.w	d0,(a0)
	move.l	a1,a0
	add.l	#65538,a0
	moveq	#70,d0
	move.w	d0,(a0)
	move.l	a1,a0
	add.l	#65536,a0
	moveq	#70,d0
	move.w	d0,(a0)
	move.w	#128,d0
	move.w	d0,2(a1)
	move.l	a1,a0
	add.l	#65542,a0
	move.w	#255,d0
	move.w	d0,(a0)
	move.l	a1,a0
	add.l	#65550,a0
	moveq	#61,d0
	move.w	d0,(a0)
	moveq	#97,d0
	move.w	d0,(a1)
	move.l	a1,a0
	add.l	#65536,a0
	moveq	#0,d0
	move.b	16(a5),d0
	move.w	d0,(a0)
	moveq	#0,d0
	move.b	17(a5),d0
	move.w	d0,2(a1)
	move.l	a1,a0
	add.l	#65538,a0
	moveq	#0,d0
	move.b	18(a5),d0
	move.w	d0,(a0)
	moveq	#0,d0
	move.b	19(a5),d0
	move.w	d0,4(a1)
	move.l	a1,a0
	add.l	#65540,a0
	moveq	#0,d0
	move.b	20(a5),d0
	move.w	d0,(a0)
	moveq	#0,d0
	move.b	21(a5),d0
	move.w	d0,6(a1)
	move.l	a1,a0
	add.l	#65542,a0
	moveq	#71,d0
	move.w	d0,(a0)
	move.l	#18176,d0
	move.l	d0,104(a5)
	clr.w	8(a1)
	move.l	a1,a0
	add.l	#65544,a0
	clr.w	(a0)
	clr.w	10(a1)
	move.l	a1,a0
	add.l	#65546,a0
	clr.w	(a0)
	clr.w	12(a1)
	move.l	a1,a0
	add.l	#65548,a0
	clr.w	(a0)
	clr.w	14(a1)
	move.l	a1,a0
	add.l	#65550,a0
	clr.w	(a0)
	moveq	#34,d0
	move.w	d0,(a1)
	moveq	#1,d0
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_reset,@function
	SIZE	_ns8390_reset,.-_ns8390_reset

; Allocations for _ns8390_reset
;	a5	ne_nif
;	not allocated	index
;	a1	ns8390
;$$bf
	ALIGN	4
	XDEF	_ns8390_start
_ns8390_start:
	link	a6,#-0
	move.l	8(a6),a0
	move.l	96(a0),a1
	moveq	#34,d0
	move.w	d0,(a1)
	move.l	a1,a0
	add.l	#65548,a0
	clr.w	(a0)
	moveq	#75,d0
	move.w	d0,14(a1)
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_start,@function
	SIZE	_ns8390_start,.-_ns8390_start

; Allocations for _ns8390_start
;	8(a6)	ne_nif
;	a1	ns8390
;$$bf
	ALIGN	4
	XDEF	_ns8390_stop
_ns8390_stop:
	link	a6,#-0
	move.l	8(a6),a0
	move.l	96(a0),a1
	moveq	#34,d0
	move.w	d0,(a1)
	move.l	a1,a0
	add.l	#65550,a0
	clr.w	(a0)
	move.l	a1,a0
	add.l	#65542,a0
	move.w	#65535,d0
	move.w	d0,(a0)
	moveq	#0,d1
.L15:
	cmp.l	#65536,d1
	jge	.L13
	addq.l	#1,d1
	jra	.L15
.L13:
	moveq	#33,d0
	move.w	d0,(a1)
;$$be
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_stop,@function
	SIZE	_ns8390_stop,.-_ns8390_stop

; Allocations for _ns8390_stop
;	8(a6)	ne_nif
;	d1	loop
;	a1	ns8390
;$$bf
	ALIGN	4
	XDEF	_ns8390_send
_ns8390_send:
	link	a6,#-0
	lea	-28(a7),a7
;$$br
	movem.l	d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	12(a6),a5
	move.l	16(a6),a4
	move.l	24(a6),d7
	move.l	28(a6),a3
	move.l	8(a6),a0
	move.l	96(a0),a2
	cmp.l	#1500,d7
	jgt	.L27
	tst.l	d7
	jgt	.L17
.L27:
	moveq	#0,d0
	jra	.L16
.L17:
	move.l	d7,d6
	moveq	#46,d0
	cmp.l	d6,d0
	jle	.L18
	moveq	#46,d6
.L18:
	btst	#0,d6
	jeq	.L19
	addq.l	#1,d6
.L19:
;$$fn 0x303
	jbsr	_board_disable_interrupts
	move.l	d6,a0
	pea	14(a0)
	pea	16384.w
	move.l	a2,-(a7)
;$$fn 0x301
	jbsr	_set_dma_write_at
	lea	12(a7),a7
	move.w	(a5),16(a2)
	move.w	2(a5),16(a2)
	move.w	4(a5),16(a2)
	move.w	(a4),16(a2)
	move.w	2(a4),16(a2)
	move.w	4(a4),16(a2)
	move.w	22(a6),16(a2)
	moveq	#0,d5
.L22:
	move.l	d5,d0
	addq.l	#1,d0
	cmp.l	d0,d7
	jle	.L20
	move.w	0(a3,d5),d0
	move.w	d0,16(a2)
	addq.l	#2,d5
	jra	.L22
.L20:
	btst	#0,d7
	jeq	.L23
	moveq	#0,d0
	move.b	-1(a3,d7),d0
	lsl.l	#8,d0
	move.w	d0,16(a2)
	addq.l	#1,d7
.L23:
	move.l	d7,d5
.L26:
	moveq	#46,d0
	cmp.l	d5,d0
	jle	.L24
	clr.w	16(a2)
	addq.l	#2,d5
	jra	.L26
.L24:
	moveq	#64,d0
	move.w	d0,4(a2)
	move.l	a2,a0
	add.l	#65540,a0
	move.l	d6,d0
	add.l	#14,d0
	and.l	#255,d0
	move.w	d0,(a0)
	moveq	#14,d0
	add.l	d6,d0
	asr.l	#8,d0
	and.l	#255,d0
	move.w	d0,6(a2)
	moveq	#38,d0
	move.w	d0,(a2)
;$$fn 0x303
	jbsr	_board_enable_interrupts
	moveq	#1,d0
.L16:
;$$be
;$$br
	movem.l	-28(a6),d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_send,@function
	SIZE	_ns8390_send,.-_ns8390_send

; Allocations for _ns8390_send
;	8(a6)	ne_nif
;	a5	eth_dest
;	a4	eth_src
;	22(a6)	eth_type
;	d7	data_length
;	a3	eth_data
;	d6	mod_data_length
;	d5	index
;	a2	ns8390
;$$bf
	ALIGN	4
	XDEF	_ns8390_receive
_ns8390_receive:
	link	a6,#-40
	lea	-40(a7),a7
;$$br
	movem.l	d2/d3/d4/d5/d6/d7/a2/a3/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	move.l	104(a4),a3
	pea	4.w
	move.l	a3,-(a7)
	move.l	a5,-(a7)
;$$fn 0x301
	jbsr	_set_dma_read_at
	lea	12(a7),a7
	moveq	#1,d5
	moveq	#0,d0
	move.w	16(a5),d0
	move.l	d0,-8(a6)
	moveq	#0,d0
	move.w	16(a5),d0
	move.l	d0,-12(a6)
	move.l	#255,d3
	and.l	-8(a6),d3
	move.l	-8(a6),d2
	asr.l	#8,d2
	and.l	#255,d2
	move.l	#255,d0
	and.l	-12(a6),d0
	lsl.l	#8,d0
	move.l	-12(a6),d1
	asr.l	#8,d1
	and.l	#255,d1
	or.l	d1,d0
	move.l	d0,-16(a6)
	btst	#0,d3
	jne	.L36
	btst	#1,d3
	jeq	.L29
	addq.l	#1,116(a4)
.L29:
	btst	#2,d3
	jeq	.L30
	addq.l	#1,116(a4)
.L30:
	btst	#3,d3
	jeq	.L31
	addq.l	#1,116(a4)
.L31:
	btst	#4,d3
	jeq	.L32
	addq.l	#1,116(a4)
.L32:
	btst	#5,d3
	jeq	.L33
	addq.l	#1,116(a4)
.L33:
	btst	#6,d3
	jeq	.L34
	addq.l	#1,116(a4)
.L34:
	tst.b	d3
	jpl	.L28
	addq.l	#1,116(a4)
	jra	.L28
.L36:
	move.l	d2,d0
	lsl.l	#8,d0
	move.l	d0,104(a4)
	cmp.l	104(a4),a3
	jls	.L39
	move.l	d2,d0
	subq.l	#1,d0
	moveq	#70,d1
	cmp.l	d0,d1
	jle	.L37
	move.l	a5,a0
	add.l	#65538,a0
	moveq	#127,d0
	move.w	d0,(a0)
	jra	.L40
.L37:
	move.l	a5,a0
	add.l	#65538,a0
	move.l	d2,d0
	add.l	#65535,d0
	move.w	d0,(a0)
	jra	.L40
.L39:
	move.l	a5,a0
	add.l	#65538,a0
	move.l	d2,d0
	add.l	#65535,d0
	move.w	d0,(a0)
.L40:
	tst.l	d5
	jeq	.L47
	pea	14.w
	pea	4(a3)
	move.l	a5,-(a7)
;$$fn 0x301
	jbsr	_set_dma_read_at
	lea	12(a7),a7
	move.w	16(a5),-32(a6)
	move.w	16(a5),-30(a6)
	move.w	16(a5),-28(a6)
	move.w	16(a5),-24(a6)
	move.w	16(a5),-22(a6)
	move.w	16(a5),-20(a6)
	move.w	16(a5),-34(a6)
	moveq	#0,d0
	move.w	-34(a6),d0
	move.l	d0,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_nif_proto
	addq.l	#8,a7
	tst.l	d0
	jne	.L41
	moveq	#0,d5
.L41:
	moveq	#0,d6
	moveq	#0,d7
.L45:
	moveq	#6,d0
	cmp.l	d7,d0
	jls	.L42
	move.b	-24(a6,d7),d0
	move.b	16(a4,d7),d1
	sub.l	d1,d0
	tst.b	d0
	jeq	.L44
	moveq	#1,d6
	jra	.L42
.L44:
	addq.l	#1,d7
	jra	.L45
.L42:
	tst.l	d6
	jne	.L47
	moveq	#0,d5
.L47:
	tst.l	d5
	jeq	.L49
;$$fn 0x303
	jbsr	_nbuf_allocate
	move.l	d0,a2
	tst.l	a2
	jne	.L49
	moveq	#0,d5
.L49:
	tst.l	d5
	jeq	.L28
	moveq	#-16,d4
	add.l	-16(a6),d4
	move.l	-16(a6),a0
	pea	-16(a0)
	pea	18(a3)
	move.l	a5,-(a7)
;$$fn 0x301
	jbsr	_set_dma_read_at
	lea	12(a7),a7
	moveq	#0,d7
.L52:
	cmp.l	d4,d7
	jge	.L50
	move.w	16(a5),d0
	move.w	d0,0(a2,d7)
	addq.l	#2,d7
	jra	.L52
.L50:
	move.l	d4,1500(a2)
	move.l	d4,-(a7)
	move.l	a2,-(a7)
	moveq	#0,d0
	move.w	-34(a6),d0
	move.l	d0,-(a7)
	move.l	a4,-(a7)
;$$fn 0x303
	jbsr	_nif_proto_handler
	lea	16(a7),a7
	move.l	d0,-4(a6)
	tst.l	d0
	jne	.L28
	move.l	a2,-(a7)
;$$fn 0x303
	jbsr	_nbuf_release
	addq.l	#4,a7
.L28:
;$$be
;$$br
	movem.l	-80(a6),d2/d3/d4/d5/d6/d7/a2/a3/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_receive,@function
	SIZE	_ns8390_receive,.-_ns8390_receive

; Allocations for _ns8390_receive
;	a5	ns8390
;	a4	ne_nif
;	-4(a6)	keep
;	d7	index
;	d6	not_me
;	d5	frame_good
;	d4	frame_length
;	d3	receive_status
;	d2	np_pointer
;	-8(a6)	a
;	-12(a6)	b
;	-16(a6)	receive_count
;	a3	current
;	-24(a6)	eth_src
;	-32(a6)	eth_dest
;	-34(a6)	eth_type
;	a2	frame
;$$bf
	ALIGN	4
	XDEF	_ns8390_handler
_ns8390_handler:
	link	a6,#-0
	lea	-12(a7),a7
;$$br
	movem.l	d7/a4/a5,(a7)
;$$er
	move.l	8(a6),a5
	move.l	12(a6),a4
	moveq	#34,d0
	move.w	d0,(a5)
	move.l	a5,a0
	add.l	#65543,a0
	moveq	#0,d7
	move.b	(a0),d7
	tst.l	d7
	jne	.L57
	moveq	#0,d0
	jra	.L56
.L57:
	btst	#0,d7
	jeq	.L58
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#1,d0
	move.w	d0,(a0)
	move.l	a4,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_ns8390_receive
	addq.l	#8,a7
	addq.l	#1,108(a4)
.L58:
	btst	#1,d7
	jeq	.L59
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#2,d0
	move.w	d0,(a0)
	addq.l	#1,112(a4)
.L59:
	btst	#2,d7
	jeq	.L60
	lea	.L65,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#4,d0
	move.w	d0,(a0)
.L60:
	btst	#3,d7
	jeq	.L61
	lea	.L66,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#8,d0
	move.w	d0,(a0)
	addq.l	#1,120(a4)
.L61:
	btst	#4,d7
	jeq	.L62
	lea	.L67,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#16,d0
	move.w	d0,(a0)
	addq.l	#1,116(a4)
.L62:
	btst	#5,d7
	jeq	.L63
	lea	.L68,a0
	move.l	a0,-(a7)
;$$fn 0x303
	jbsr	_printD
	addq.l	#4,a7
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#32,d0
	move.w	d0,(a0)
.L63:
	btst	#6,d7
	jeq	.L64
	move.l	a5,a0
	add.l	#65542,a0
	moveq	#64,d0
	move.w	d0,(a0)
.L64:
	moveq	#1,d0
.L56:
;$$be
;$$br
	movem.l	-12(a6),d7/a4/a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_handler,@function
	SIZE	_ns8390_handler,.-_ns8390_handler

; Allocations for _ns8390_handler
;	a5	ns8390
;	a4	ne_nif
;	d7	isr
;$$bf
	ALIGN	4
	XDEF	_ns8390_init
_ns8390_init:
	link	a6,#-0
;$$br
	move.l	a5,-(a7)
;$$er
	move.l	8(a6),a5
	lea	.L70,a0
	move.l	a0,-(a7)
	move.l	a5,-(a7)
;$$fn 0x303
	jbsr	_nif_create
	addq.l	#8,a7
	move.l	12(a6),96(a5)
	move.l	16(a6),100(a5)
	pea	16(a5)
	move.l	96(a5),-(a7)
;$$fn 0x303
	jbsr	_read_eth_addr
	addq.l	#8,a7
	moveq	#6,d0
	move.l	d0,28(a5)
	move.l	#1500,d0
	move.l	d0,32(a5)
	move.l	#_ns8390_reset,d0
	move.l	d0,76(a5)
	move.l	#_ns8390_start,d0
	move.l	d0,80(a5)
	move.l	#_ns8390_stop,d0
	move.l	d0,84(a5)
	move.l	#_ns8390_send,d0
	move.l	d0,88(a5)
	move.l	#_ns8390_receive,d0
	move.l	d0,92(a5)
	moveq	#1,d0
;$$be
;$$br
	move.l	-4(a6),a5
;$$er
	unlk	a6
	rts
;$$ef
	TYPE	_ns8390_init,@function
	SIZE	_ns8390_init,.-_ns8390_init

; Allocations for _ns8390_init
;	a5	ne_nif
;	12(a6)	base
;	16(a6)	vector

; Allocations for module
	ALIGN	4
.L65:
	ASCII	"NS8390 RXE Receiver Error\n"
	DC.B	0
	ALIGN	4
.L66:
	ASCII	"NS8390 TXE Transmitter Error\n"
	DC.B	0
	ALIGN	4
.L67:
	ASCII	"NS8390 OVW Buffer Overflow\n"
	DC.B	0
	ALIGN	4
.L68:
	ASCII	"NS8390 CNT\n"
	DC.B	0
	ALIGN	4
.L70:
	ASCII	"ns8390"
	DC.B	0
	
